/* SerialPort.h: interface for the SerialPort class.
Copyright (C) 2006  Rohit Rawat

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include <string>
#include <windows.h>

class SerialPort  
{
public:
	SerialPort();
	virtual ~SerialPort();

	int open();
	int setPort(std::string port1);
	int setBaud(unsigned long baud1);
	int setBytes(unsigned char bytes1);
	int setParity(unsigned char parity1);
	int setStopBits(unsigned char stopBits1);
	int readBytes(char *buf, int size);
	int writeBytes(char *buf, int size);
	int close();

private:
	bool ok;
	std::string port;
	unsigned long baud;
	unsigned char bytes;
	unsigned char parity;
	unsigned char stopBits;
	HANDLE handle;
	DCB dcb;
	COMMTIMEOUTS timeouts;

};

